package sbktech.tools.scm;
import java.util.*;

public class Symbol implements Obj
{
  static Hashtable internset = new Hashtable();
  String name;
  public Symbol(String s) { name = s; }

  public static Symbol intern(String s)
  {
    Symbol ret;

    if ((ret = (Symbol)internset.get(s)) == null)
      { ret = new Symbol(s); internset.put(s, ret); }
    return ret;
  }

  public Obj eval(Env e)
  { return e.lookup(this); }

  public String toString()
  {
    return(name);
  }
}
